vRP = Proxy.getInterface("vRP")

local Keys = {
    ["ESC"] = 322, ["F1"] = 288, ["F2"] = 289, ["F3"] = 170, ["F5"] = 166, ["F6"] = 167, ["F7"] = 168, ["F8"] = 169, ["F9"] = 56, ["F10"] = 57,
    ["~"] = 243, ["1"] = 157, ["2"] = 158, ["3"] = 160, ["4"] = 164, ["5"] = 165, ["6"] = 159, ["7"] = 161, ["8"] = 162, ["9"] = 163, ["-"] = 84, ["="] = 83, ["BACKSPACE"] = 177,
    ["TAB"] = 37, ["Q"] = 44, ["W"] = 32, ["E"] = 38, ["R"] = 45, ["T"] = 245, ["Y"] = 246, ["U"] = 303, ["P"] = 199, ["["] = 39, ["]"] = 40, ["ENTER"] = 18,
    ["CAPS"] = 137, ["A"] = 34, ["S"] = 8, ["D"] = 9, ["F"] = 23, ["G"] = 47, ["H"] = 74, ["K"] = 311, ["L"] = 182,
    ["LEFTSHIFT"] = 21, ["Z"] = 20, ["X"] = 73, ["C"] = 26, ["V"] = 0, ["B"] = 29, ["N"] = 249, ["M"] = 244, [","] = 82, ["."] = 81,
    ["LEFTCTRL"] = 36, ["LEFTALT"] = 19, ["SPACE"] = 22, ["RIGHTCTRL"] = 70,
    ["HOME"] = 213, ["PAGEUP"] = 10, ["PAGEDOWN"] = 11, ["DELETE"] = 178,
    ["LEFT"] = 174, ["RIGHT"] = 175, ["TOP"] = 27, ["DOWN"] = 173,
    ["NENTER"] = 201, ["N4"] = 108, ["N5"] = 60, ["N6"] = 107, ["N+"] = 96, ["N-"] = 97, ["N7"] = 117, ["N8"] = 61, ["N9"] = 118
}

local outfit = {
    ['male'] = {
        ped = 'mp_m_freemode_01',
        props = {
            -- {0,0,0}, -- Hat
            -- {1,0,0}, -- Glasses
            -- {2,0,0}, -- ears
			-- {4,0,0}, -- hair
            -- {3,0,0}, -- mouth
            -- {6,0,0}, -- watches (lwrist)
        },
        components = {
            {1,0,0}, -- mask
			{3,180,1}, -- Arms & Gloves
            {4,195,1}, -- Pants
            {5,0,1}, -- Bags
            {6,161,1}, -- Shoes
            {7,0,0}, -- Scarf & necklance
            {8,101,0}, -- Undershirt
            {9,0,6}, -- Vest
            {10,0,0}, -- Decals
            {11,354,1},  -- Jacket
        }
    }
}


local HasAlreadyEnteredMarker = false
local LastZone = nil
local CurrentAction = nil
local CurrentActionMsg = ''
local onDuty = false
local Blips = {}

Citizen.CreateThread(function()

	local blip = AddBlipForCoord(247.57411193848,-3316.4052734375,5.7903146743774)
	SetBlipSprite(blip, 308)
	SetBlipDisplay(blip, 4)
	SetBlipScale(blip, 0.6)
	SetBlipColour(blip, 59)
	SetBlipAsShortRange(blip, true)
	BeginTextCommandSetBlipName("STRING")
	AddTextComponentString("[JOB] Scafandru")
	EndTextCommandSetBlipName(blip)

end)

function SelectPool()
	local index = GetRandomIntInRange(1, #Config.Pool)

	for k,v in pairs(Config.Zones) do
		if v.Pos.x == Config.Pool[index].x and v.Pos.y == Config.Pool[index].y and v.Pos.z == Config.Pool[index].z then
			return k
		end
	end
end

function StartNPCJob()
	NPCTargetPool = SelectPool()
	local zone = Config.Zones[NPCTargetPool]

	Blips['NPCTargetPool'] = AddBlipForCoord(zone.Pos.x, zone.Pos.y, zone.Pos.z)
	SetBlipRoute(Blips['NPCTargetPool'], true)
	vRP.notify({Config.locales['GPS_info']})
	Done = true
end

function StopNPCJob(cancel)
	if Blips['NPCTargetPool'] ~= nil then
		RemoveBlip(Blips['NPCTargetPool'])
		Blips['NPCTargetPool'] = nil
	end

	OnJob = false

	if cancel then
		vRP.notify({Config.locales['cancel_mission']})
	else
		TriggerServerEvent('asdasdjasasjdfgaskdbnajsgdk124512')
		StartNPCJob()
		Done = true
	end
end

Citizen.CreateThread(function()
	ticks = 500
	while true do

		if NPCTargetPool ~= nil then
			local playerPed = PlayerPedId()
			local coords = GetEntityCoords(playerPed)
			local zone = Config.Zones[NPCTargetPool]
			local zonevec = vector3(zone.Pos.x,zone.Pos.y,zone.Pos.z)
			SetPedMaxTimeUnderwater(PlayerPedId(), 1500.00)

			if GetDistanceBetweenCoords(coords, zone.Pos.x, zone.Pos.y, zone.Pos.z, true) < 15 then
				ticks = 1
				DrawMarker(2,zone.Pos.x,zone.Pos.y,zone.Pos.z, 0,0,0,0,0,0,0.5,0.5,0.5,255,255,0,165,0,0,0,0)
			end

			if GetDistanceBetweenCoords(coords, zone.Pos.x, zone.Pos.y, zone.Pos.z, true) < 3 then
				ticks = 1
				DrawText3D(zone.Pos.x, zone.Pos.y, zone.Pos.z,Config.locales['pickup'])
				

				if IsControlJustReleased(1, Keys["E"]) then
					TaskStartScenarioInPlace(playerPed, 'WORLD_HUMAN_WELDING', 0, true)
					Citizen.Wait(17000)
					StopNPCJob()
					Citizen.Wait(3000)
					ClearPedTasksImmediately(playerPed)
					Done = false
				end
			end
		end
		Citizen.Wait(ticks)
	end
end)

function loadAnimDict( dict )
    while ( not HasAnimDictLoaded( dict ) ) do
        RequestAnimDict( dict )
        Citizen.Wait( 0 )
    end
end

function CloakRoomMenu()

	if onDuty then
		vRP.notify({Config.locales['end_service_notif']})
		TriggerEvent("raid_clothes:incarcaHainele")
		onDuty = false
		if Blips['NPCTargetPool'] ~= nil then
			RemoveBlip(Blips['NPCTargetPool'])
			Blips['NPCTargetPool'] = nil
		end
	else
		playerPedax = PlayerPedId()
		if IsPedArmed(playerPedax, 7) then
			SetCurrentPedWeapon(playerPedax, GetHashKey('WEAPON_UNARMED'), true)
		end
		ClearPedSecondaryTask(playerPedax)
		loadAnimDict( "clothingtie" ) 
		TaskPlayAnim(playerPedax, "clothingtie", "try_tie_negative_a", 8.0, -8, -1, 49, 0, -1, -1, -1)
		exports.rprogress:Start("Te imbraci...", 1700)
		ClearPedTasks(playerPedax)
		AXChangeClothes()
		onDuty = true
		vRP.notify({Config.locales['take_service_notif']})
	end
	CurrentAction     = 'cloakroom_menu'
	CurrentActionMsg  = Config.Zones.Cloakroom.hint
	CurrentActionData = {}
end

function VehicleMenu()
	local playerPed = PlayerPedId()
	local carhash = GetHashKey("dinghy")
	local plateNum = math.random(1000, 9999)
	local platePrefix = Config.PlatePrefix
	while not HasModelLoaded(carhash) do
		RequestModel(carhash)
		Citizen.Wait(10)
	end
	if HasModelLoaded(carhash) then 
		SetModelAsNoLongerNeeded(carhash)
		vehicle = CreateVehicle(carhash,Config.Zones.VehicleSpawnPoint.Pos.x,Config.Zones.VehicleSpawnPoint.Pos.y,Config.Zones.VehicleSpawnPoint.Pos.z, Config.Zones.VehicleSpawnPoint.Heading, true, false)
		Citizen.InvokeNative(0xAD738C3085FE7E11, vehicle, true, true)
		SetVehicleNumberPlateText(vehicle,  platePrefix .. plateNum)
		TaskWarpPedIntoVehicle(playerPed,vehicle,-1)
	end
	vRP.notify({Config.locales['start_job']})
	CurrentAction     = 'vehiclespawn_menu'
	CurrentActionMsg  = Config.Zones.VehicleSpawner.hint
	CurrentActionData = {}

end

AddEventHandler('lasldlasldlalsdlasldlasld', function(zone)

	if zone == 'Cloakroom' then
		CurrentAction     = 'cloakroom_menu'
		CurrentActionMsg  = Config.Zones.Cloakroom.hint
		CurrentActionData = {}
	elseif zone == 'VehicleSpawner' then
		CurrentAction     = 'vehiclespawn_menu'
		CurrentActionMsg  = Config.Zones.VehicleSpawner.hint
		CurrentActionData = {}
	elseif zone == 'VehicleDeleter' then

		local playerPed = PlayerPedId()
		if IsPedInAnyVehicle(playerPed, false) then
			local vehicle = GetVehiclePedIsIn(playerPed, false)

			if GetPedInVehicleSeat(vehicle, -1) == playerPed then
				CurrentAction     = 'delete_vehicle'
				CurrentActionMsg  = Config.Zones.VehicleDeleter.hint
				CurrentActionData = {}
			end
		end

	elseif zone == 'Vente' then
		CurrentAction     = 'vente'
		CurrentActionMsg  = Config.Zones.Vente.hint
		CurrentActionData = {}
	end
end)

AddEventHandler('asaskd8888sdjjsdjksnajsgdk124512', function(zone)
	if zone == 'Vente' then
		TriggerServerEvent('asaskdkaskdkaskdaksnajsgdk124512')
		ClearPedTasks(PlayerPedId())
	end

	CurrentAction = nil
end)


Citizen.CreateThread(function()
	while true do
		ticks = 500
			local coords = GetEntityCoords(PlayerPedId())

				if onDuty then

					for _,v in pairs(Config.Zones) do
						if v ~= Config.Zones.Cloakroom then
							if(v.Type ~= -1 and GetDistanceBetweenCoords(coords, v.Pos.x, v.Pos.y, v.Pos.z, true) < Config.DrawDistance) then
								ticks = 1
								DrawMarker(v.Type, v.Pos.x, v.Pos.y, v.Pos.z, 0.0, 0.0, 0.0, 0, 0.0, 0.0, v.Size.x, v.Size.y, v.Size.z, v.Color.r, v.Color.g, v.Color.b, 100, false, true, 2, false, false, false, false)
							end
						end
					end

				end

				local Cloakroom = Config.Zones.Cloakroom
				if(Cloakroom.Type ~= -1 and GetDistanceBetweenCoords(coords, Cloakroom.Pos.x, Cloakroom.Pos.y, Cloakroom.Pos.z, true) < Config.DrawDistance) then
					ticks = 1
					DrawMarker(Cloakroom.Type, Cloakroom.Pos.x, Cloakroom.Pos.y, Cloakroom.Pos.z, 0.0, 0.0, 0.0, 0, 0.0, 0.0, Cloakroom.Size.x, Cloakroom.Size.y, Cloakroom.Size.z, Cloakroom.Color.r, Cloakroom.Color.g, Cloakroom.Color.b, 100, false, true, 2, false, false, false, false)
				end
		Citizen.Wait(ticks)
	end
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(10)
		

			local coords      = GetEntityCoords(PlayerPedId())
			local isInMarker  = false
			local currentZone = nil
			
				if onDuty then
					for k,v in pairs(Config.Zones) do
						if v ~= Config.Zones.Cloakroom then
							if(GetDistanceBetweenCoords(coords, v.Pos.x, v.Pos.y, v.Pos.z, true) <= v.Size.x) then
								isInMarker  = true
								currentZone = k
							end
						end
					end
				end
				local Cloakroom = Config.Zones.Cloakroom
				if(GetDistanceBetweenCoords(coords, Cloakroom.Pos.x, Cloakroom.Pos.y, Cloakroom.Pos.z, true) <= Cloakroom.Size.x) then
					isInMarker  = true
					currentZone = "Cloakroom"
				end

			if (isInMarker and not HasAlreadyEnteredMarker) or (isInMarker and LastZone ~= currentZone) then
				HasAlreadyEnteredMarker = true
				LastZone                = currentZone
				TriggerEvent('lasldlasldlalsdlasldlasld', currentZone)
			end
			if not isInMarker and HasAlreadyEnteredMarker then
				HasAlreadyEnteredMarker = false
				TriggerEvent('asaskd8888sdjjsdjksnajsgdk124512', LastZone)
			end
	end
end)

function axscf_DisplayHelpText(str)
	SetTextComponentFormat("STRING")
	AddTextComponentString(str)
	DisplayHelpTextFromStringLabel(0, 0, 1, -1)
end

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(10)
		if CurrentAction ~= nil then
			axscf_DisplayHelpText(CurrentActionMsg)

			if (IsControlJustReleased(1, Keys["E"]) or IsControlJustReleased(2, Keys["RIGHT"])) then
				local playerPed = PlayerPedId()

					if CurrentAction == 'cloakroom_menu' then

						if IsPedInAnyVehicle(playerPed, false) then
							vRP.notify({Config.locales['in_vehicle']})
						else
							CloakRoomMenu()
						end

					elseif CurrentAction == 'vehiclespawn_menu' then

						if IsPedInAnyVehicle(playerPed, false) then
							vRP.notify({Config.locales['in_vehicle']})
						else
							VehicleMenu()
						end

					elseif CurrentAction == 'vente' then

						TriggerServerEvent('asdasasdasgfhgnhjjmnajsgdk124512')
						TaskStartScenarioInPlace(playerPed, "WORLD_HUMAN_CLIPBOARD", 0, 1)

					elseif CurrentAction == 'delete_vehicle' then

						local playerPed = PlayerPedId()
						local vehicle = GetVehiclePedIsIn(playerPed, false)
						local hash = GetEntityModel(vehicle)
						local plate = GetVehicleNumberPlateText(vehicle)

						local platePrefix = Config.PlatePrefix

						if string.find(plate, platePrefix) then
							local truck = Config.Vehicles.Truck

							if hash == GetHashKey(truck.Hash) then
								if GetVehicleEngineHealth(vehicle) <= 500 or GetVehicleBodyHealth(vehicle) <= 500 then
									vRP.notify({Config.locales['vehicle_broken']})
								else
									DeleteVehicle(vehicle)
								end
							end
						else
							vRP.notify({Config.locales['bad_vehicle']})
						end

					end

					CurrentAction = nil
			end
		end
	end
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(10)

		if IsControlJustReleased(1, Keys["F10"]) then

			if Onjob then
				StopNPCJob(true)
				RemoveBlip(Blips['NPCTargetPool'])
				Onjob = false
			else
				local playerPed = PlayerPedId()

				if IsPedInAnyVehicle(playerPed, false) and IsVehicleModel(GetVehiclePedIsIn(playerPed, false), GetHashKey("dinghy")) then
					StartNPCJob()
					Onjob = true
				else
					vRP.notify({Config.locales['not_good_veh']})
				end
			end
		end
	end
end)



DrawText3D = function(x, y, z, text)
    local onScreen, _x, _y = World3dToScreen2d(x, y, z)
    local scale = 0.35
    if onScreen then
        SetTextScale(scale, scale)
        SetTextFont(4)
        SetTextProportional(1)
        SetTextColour(255, 255, 255, 215)
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x, _y)
        local factor = (string.len(text)) / 370
        DrawRect(_x, _y + 0.0150, 0.030 + factor, 0.030, 66, 66, 66, 150)
    end
end

function AXChangeClothes()
	local ped = PlayerPedId()
	RequestModel(outfit['male'].ped)

	while not HasModelLoaded(outfit['male'].ped) do
		Wait(0)
	end

	if GetEntityModel(ped) ~= GetHashKey(outfit['male'].ped) then
		SetPlayerModel(PlayerId(), outfit['male'].ped)
	end

	ped = PlayerPedId()

	for _, comp in ipairs(outfit['male'].components) do
	   SetPedComponentVariation(ped, comp[1], comp[2], comp[3], 0)
	end

	for _, comp in ipairs(outfit['male'].props) do
		if comp[2] == 0 then
			ClearPedProp(ped, comp[1])
		else
			SetPedPropIndex(ped, comp[1], comp[2], comp[3], true)
		end
	end

end

